'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
function getModuleOpts(opts) {
  var cwd = require('cwd');
  var _ = require('lodash');

  var srcDir = cwd('modules');
  var destDir = 'lib-modules';

  // TODO(vjpr): This is very bad! We should make each task generic. Should export just functions.
  // Or this might be fine.
  opts = _.merge({}, opts, {
    srcGlob: srcDir + '/**/*.js',
    srcFilesGlob: srcDir + '/**/!(*.js|*.jsx)',
    destGlob: destDir + '/**/*',
    testsGlob: srcDir + '/**/__tests__/**/*-test.js',
    shouldCompileTests: false,
    babel: {}, // See src/config.
    srcDir: srcDir,
    destDir: destDir,
    sourceMaps: false
  });

  return opts;
}

exports.default = function (gulp, opts) {

  opts = getModuleOpts(opts);

  gulp.task('flow-modules:check', function (done) {
    var _require = require('child_process');

    var spawnSync = _require.spawnSync;

    // TODO(vjpr): Limit output to fit on screen to allow user to work through errors from first to last.
    // TODO(vjpr): Show notification bubble if there is output.

    spawnSync('flow', ['status', '--no-auto-start'], { stdio: 'inherit' });
    done();
  });

  gulp.task('flow-modules:watch', gulp.series('flow-modules:check', function watcher() {
    var gutil = require('gulp-util');

    // Used by `compile` task to check whether we should only compile changed files.
    gulp.isWatching = true;

    // Sometimes we might want to use src, sometimes something else.
    gulp.watch(opts.srcGlob, gulp.series('flow-modules:check')).on('change', function (evt) {
      gutil.log('---');
      gutil.log('File changed:', gutil.colors.red(evt.path));
    });
  }));

  // TODO(vjpr): Do.
  //gulp.task('flow:bootstrap')
};

var flowConfig = '';
module.exports = exports['default'];