// TODO(vjpr): Use https://github.com/slushjs/gulp-conflict/blob/master/index.js

module.exports = function(fn, done) {

  //region Imports
  const jsondiffpatch = require('jsondiffpatch')
  const confirm = require('inquirer-confirm')
  const fs = require('fs')
  const cwd = require('cwd')
  const _ = require('lodash')
  const chalk = require('chalk')
  const {log} = console
  //endregion

  const pjsonPath = cwd('package.json')
  const oldJson = JSON.parse(fs.readFileSync(pjsonPath, 'utf8')) // Don't use `require` because it caches!
  let json = _.cloneDeep(oldJson)
  json = fn(json)
  const delta = jsondiffpatch.diff(oldJson, json)
  if (!delta) {
    log('Skipping ' + chalk.magenta('package.json') + ' (already up to date)')
    return done()
  }
  log('Proposed changes to:', pjsonPath)
  log()
  jsondiffpatch.console.log(delta)
  log()
  confirm('Write?').then(() => {
    fs.writeFileSync(pjsonPath, JSON.stringify(json, null, 2))
    log(chalk.green('Wrote file.'))
    done()
  }, () => {
    done('Cancelled.')
  })

}
